
#ifndef GL_CORE_EXTENSION
#   define GL_CORE_EXTENSION(_ext, _major, _minor) 
#endif

#ifndef GL_EXTENSION
#   define GL_EXTENSION(_ext) 
#endif

#ifndef GL_EXTENSION_FUNC
#   define GL_EXTENSION_FUNC(_ext, _procType, _procName)
#endif

// Do not prevent multiple inclusion or this file won't work.

GL_EXTENSION(OpenGL)
    GL_EXTENSION_FUNC(OpenGL, PFNGLACTIVETEXTUREPROC, glActiveTexture)
    GL_EXTENSION_FUNC(OpenGL, PFNGLATTACHSHADERPROC, glAttachShader)
    GL_EXTENSION_FUNC(OpenGL, PFNGLBEGINQUERYPROC, glBeginQuery)
    GL_EXTENSION_FUNC(OpenGL, PFNGLBINDBUFFERPROC, glBindBuffer)
    GL_EXTENSION_FUNC(OpenGL, PFNGLBUFFERDATAPROC, glBufferData)
    GL_EXTENSION_FUNC(OpenGL, PFNGLBUFFERSUBDATAPROC, glBufferSubData)
    GL_EXTENSION_FUNC(OpenGL, PFNGLCLEARBUFFERFVPROC, glClearBufferfv)
    GL_EXTENSION_FUNC(OpenGL, PFNGLCLEARDEPTHFPROC, glClearDepthf)
    GL_EXTENSION_FUNC(OpenGL, PFNGLCOMPILESHADERPROC, glCompileShader)
    GL_EXTENSION_FUNC(OpenGL, PFNGLCOMPRESSEDTEXIMAGE2DPROC, glCompressedTexImage2D)
    GL_EXTENSION_FUNC(OpenGL, PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC, glCompressedTexSubImage2D)
    GL_EXTENSION_FUNC(OpenGL, PFNGLCREATEPROGRAMPROC, glCreateProgram)
    GL_EXTENSION_FUNC(OpenGL, PFNGLCREATESHADERPROC, glCreateShader)
    GL_EXTENSION_FUNC(OpenGL, PFNGLDELETEBUFFERSPROC, glDeleteBuffers)
    GL_EXTENSION_FUNC(OpenGL, PFNGLDELETEPROGRAMPROC, glDeleteProgram)
    GL_EXTENSION_FUNC(OpenGL, PFNGLDELETEQUERIESPROC, glDeleteQueries)
    GL_EXTENSION_FUNC(OpenGL, PFNGLDELETESHADERPROC, glDeleteShader)
    GL_EXTENSION_FUNC(OpenGL, PFNGLDISABLEVERTEXATTRIBARRAYPROC, glDisableVertexAttribArray)
    GL_EXTENSION_FUNC(OpenGL, PFNGLDRAWELEMENTSINSTANCEDPROC, glDrawElementsInstanced)
    GL_EXTENSION_FUNC(OpenGL, PFNGLENABLEVERTEXATTRIBARRAYPROC, glEnableVertexAttribArray)
    GL_EXTENSION_FUNC(OpenGL, PFNGLENDQUERYPROC, glEndQuery)
    GL_EXTENSION_FUNC(OpenGL, PFNGLGENBUFFERSPROC, glGenBuffers)
    GL_EXTENSION_FUNC(OpenGL, PFNGLGENQUERIESPROC, glGenQueries)
    GL_EXTENSION_FUNC(OpenGL, PFNGLGETATTRIBLOCATIONPROC, glGetAttribLocation)
    GL_EXTENSION_FUNC(OpenGL, PFNGLGETQUERYOBJECTUIVPROC, glGetQueryObjectuiv)
    GL_EXTENSION_FUNC(OpenGL, PFNGLGETSHADERINFOLOGPROC, glGetShaderInfoLog)
    GL_EXTENSION_FUNC(OpenGL, PFNGLGETSHADERIVPROC, glGetShaderiv)
    GL_EXTENSION_FUNC(OpenGL, PFNGLGETUNIFORMLOCATIONPROC, glGetUniformLocation)
    GL_EXTENSION_FUNC(OpenGL, PFNGLGETPROGRAMINFOLOGPROC, glGetProgramInfoLog)
    GL_EXTENSION_FUNC(OpenGL, PFNGLGETPROGRAMIVPROC, glGetProgramiv)
    GL_EXTENSION_FUNC(OpenGL, PFNGLLINKPROGRAMPROC, glLinkProgram)
    GL_EXTENSION_FUNC(OpenGL, PFNGLMEMORYBARRIERPROC, glMemoryBarrier)
    GL_EXTENSION_FUNC(OpenGL, PFNGLSHADERSOURCEPROC, glShaderSource)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUNIFORM1FPROC, glUniform1f)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUNIFORM1IPROC, glUniform1i)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUNIFORM1IVPROC, glUniform1iv)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUNIFORM3FPROC, glUniform3f)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUNIFORM3FVPROC, glUniform3fv)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUNIFORM4FPROC, glUniform4f)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUNIFORM4FVPROC, glUniform4fv)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUNIFORMMATRIX4FVPROC, glUniformMatrix4fv)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUNMAPBUFFERPROC, glUnmapBuffer)
    GL_EXTENSION_FUNC(OpenGL, PFNGLUSEPROGRAMPROC, glUseProgram)
    GL_EXTENSION_FUNC(OpenGL, PFNGLVERTEXATTRIB2FPROC, glVertexAttrib2f)
    GL_EXTENSION_FUNC(OpenGL, PFNGLVERTEXATTRIB3FPROC, glVertexAttrib3f)
    GL_EXTENSION_FUNC(OpenGL, PFNGLVERTEXATTRIB4FPROC, glVertexAttrib4f)
    GL_EXTENSION_FUNC(OpenGL, PFNGLVERTEXATTRIBDIVISORPROC, glVertexAttribDivisor)
    GL_EXTENSION_FUNC(OpenGL, PFNGLVERTEXATTRIBIPOINTERPROC, glVertexAttribIPointer)
    GL_EXTENSION_FUNC(OpenGL, PFNGLVERTEXATTRIBPOINTERPROC, glVertexAttribPointer)

GL_EXTENSION(ARB_base_instance)
    GL_EXTENSION_FUNC(ARB_base_instance, PFNGLDRAWARRAYSINSTANCEDBASEINSTANCEPROC, glDrawArraysInstancedBaseInstance)
    GL_EXTENSION_FUNC(ARB_base_instance, PFNGLDRAWELEMENTSINSTANCEDBASEINSTANCEPROC, glDrawElementsInstancedBaseInstance)
    GL_EXTENSION_FUNC(ARB_base_instance, PFNGLDRAWELEMENTSINSTANCEDBASEVERTEXBASEINSTANCEPROC, glDrawElementsInstancedBaseVertexBaseInstance)

GL_EXTENSION(ARB_bindless_texture)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLGETTEXTUREHANDLEARBPROC, glGetTextureHandleARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLGETTEXTURESAMPLERHANDLEARBPROC, glGetTextureSamplerHandleARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLMAKETEXTUREHANDLERESIDENTARBPROC, glMakeTextureHandleResidentARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLMAKETEXTUREHANDLENONRESIDENTARBPROC, glMakeTextureHandleNonResidentARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLGETIMAGEHANDLEARBPROC, glGetImageHandleARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLMAKEIMAGEHANDLERESIDENTARBPROC, glMakeImageHandleResidentARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLMAKEIMAGEHANDLENONRESIDENTARBPROC, glMakeImageHandleNonResidentARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLUNIFORMHANDLEUI64ARBPROC, glUniformHandleui64ARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLUNIFORMHANDLEUI64VARBPROC, glUniformHandleui64vARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLPROGRAMUNIFORMHANDLEUI64ARBPROC, glProgramUniformHandleui64ARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLPROGRAMUNIFORMHANDLEUI64VARBPROC, glProgramUniformHandleui64vARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLISTEXTUREHANDLERESIDENTARBPROC, glIsTextureHandleResidentARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLISIMAGEHANDLERESIDENTARBPROC, glIsImageHandleResidentARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLVERTEXATTRIBL1UI64ARBPROC, glVertexAttribL1ui64ARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLVERTEXATTRIBL1UI64VARBPROC, glVertexAttribL1ui64vARB)
    GL_EXTENSION_FUNC(ARB_bindless_texture, PFNGLGETVERTEXATTRIBLUI64VARBPROC, glGetVertexAttribLui64vARB)

GL_EXTENSION(ARB_buffer_storage)
    GL_EXTENSION_FUNC(ARB_buffer_storage, PFNGLBUFFERSTORAGEPROC, glBufferStorage)

GL_EXTENSION(ARB_debug_output)
    GL_EXTENSION_FUNC(ARB_debug_output, PFNGLDEBUGMESSAGECONTROLPROC, glDebugMessageControl)
    GL_EXTENSION_FUNC(ARB_debug_output, PFNGLDEBUGMESSAGECALLBACKPROC, glDebugMessageCallback)

GL_EXTENSION(ARB_internalformat_query)
    GL_EXTENSION_FUNC(ARB_internalformat_query, PFNGLGETINTERNALFORMATIVPROC, glGetInternalformativ)

GL_CORE_EXTENSION(ARB_map_buffer_range, 3, 0)
    GL_EXTENSION_FUNC(ARB_map_buffer_range, PFNGLFLUSHMAPPEDBUFFERRANGEPROC, glFlushMappedBufferRange)
    GL_EXTENSION_FUNC(ARB_map_buffer_range, PFNGLMAPBUFFERRANGEPROC, glMapBufferRange)

GL_EXTENSION(ARB_multi_draw_indirect)
    GL_EXTENSION_FUNC(ARB_multi_draw_indirect, PFNGLMULTIDRAWARRAYSINDIRECTPROC, glMultiDrawArraysIndirect)
    GL_EXTENSION_FUNC(ARB_multi_draw_indirect, PFNGLMULTIDRAWELEMENTSINDIRECTPROC, glMultiDrawElementsIndirect)

GL_EXTENSION(ARB_shader_draw_parameters)

GL_EXTENSION(ARB_shader_storage_buffer_object)
    GL_EXTENSION_FUNC(ARB_shader_storage_buffer_object, PFNGLSHADERSTORAGEBLOCKBINDINGPROC, glShaderStorageBlockBinding)
    
GL_CORE_EXTENSION(ARB_sync, 3, 2)
    GL_EXTENSION_FUNC(ARB_sync, PFNGLFENCESYNCPROC, glFenceSync)
    GL_EXTENSION_FUNC(ARB_sync, PFNGLISSYNCPROC, glIsSync)
    GL_EXTENSION_FUNC(ARB_sync, PFNGLDELETESYNCPROC, glDeleteSync)
    GL_EXTENSION_FUNC(ARB_sync, PFNGLCLIENTWAITSYNCPROC, glClientWaitSync)
    GL_EXTENSION_FUNC(ARB_sync, PFNGLWAITSYNCPROC, glWaitSync)
    GL_EXTENSION_FUNC(ARB_sync, PFNGLGETINTEGER64VPROC, glGetInteger64v)
    GL_EXTENSION_FUNC(ARB_sync, PFNGLGETSYNCIVPROC, glGetSynciv)

GL_EXTENSION(ARB_sparse_texture)
    GL_EXTENSION_FUNC(ARB_sparse_texture, PFNGLTEXPAGECOMMITMENTARBPROC, glTexPageCommitmentARB)
    GL_EXTENSION_FUNC(ARB_sparse_texture, PFNGLTEXTUREPAGECOMMITMENTEXTPROC, glTexturePageCommitmentEXT)

GL_CORE_EXTENSION(ARB_vertex_array_object, 3, 0)
    GL_EXTENSION_FUNC(ARB_vertex_array_object, PFNGLBINDVERTEXARRAYPROC, glBindVertexArray)
    GL_EXTENSION_FUNC(ARB_vertex_array_object, PFNGLDELETEVERTEXARRAYSPROC, glDeleteVertexArrays)
    GL_EXTENSION_FUNC(ARB_vertex_array_object, PFNGLGENVERTEXARRAYSPROC, glGenVertexArrays)
    GL_EXTENSION_FUNC(ARB_vertex_array_object, PFNGLGENVERTEXARRAYSPROC, glIsVertexArray)

GL_EXTENSION(ARB_texture_storage)
    GL_EXTENSION_FUNC(ARB_texture_storage, PFNGLTEXSTORAGE1DPROC, glTexStorage1D)
    GL_EXTENSION_FUNC(ARB_texture_storage, PFNGLTEXSTORAGE2DPROC, glTexStorage2D)
    GL_EXTENSION_FUNC(ARB_texture_storage, PFNGLTEXSTORAGE3DPROC, glTexStorage3D)

GL_EXTENSION(ARB_timer_query)
    GL_EXTENSION_FUNC(ARB_timer_query, PFNGLGETQUERYOBJECTI64VPROC, glGetQueryObjecti64v)

GL_CORE_EXTENSION(ARB_uniform_buffer_object, 3, 1)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETUNIFORMINDICESPROC, glGetUniformIndices)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETACTIVEUNIFORMSIVPROC, glGetActiveUniformsiv)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETACTIVEUNIFORMNAMEPROC, glGetActiveUniformName)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETUNIFORMBLOCKINDEXPROC, glGetUniformBlockIndex)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETACTIVEUNIFORMBLOCKIVPROC, glGetActiveUniformBlockiv)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETACTIVEUNIFORMBLOCKNAMEPROC, glGetActiveUniformBlockName)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLBINDBUFFERRANGEPROC, glBindBufferRange)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLBINDBUFFERBASEPROC, glBindBufferBase)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETINTEGERI_VPROC, glGetIntegeri_v)
    GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLUNIFORMBLOCKBINDINGPROC, glUniformBlockBinding)

// Note: glCompressedTexSubImage3D is actually part of GL 1.3--but we only want to use it in the context
// of texture arrays (3.0), so we gate it's presence on that extension instead.
GL_EXTENSION(EXT_texture_array)
    GL_EXTENSION_FUNC(EXT_texture_array, PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC, glCompressedTexSubImage3D)

GL_EXTENSION(NV_shader_buffer_load)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLMAKEBUFFERRESIDENTNVPROC, glMakeBufferResidentNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLMAKEBUFFERNONRESIDENTNVPROC, glMakeBufferNonResidentNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLISBUFFERRESIDENTNVPROC, glIsBufferResidentNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLMAKENAMEDBUFFERRESIDENTNVPROC, glMakeNamedBufferResidentNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLMAKENAMEDBUFFERNONRESIDENTNVPROC, glMakeNamedBufferNonResidentNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLISNAMEDBUFFERRESIDENTNVPROC, glIsNamedBufferResidentNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLGETBUFFERPARAMETERUI64VNVPROC, glGetBufferParameterui64vNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLGETNAMEDBUFFERPARAMETERUI64VNVPROC, glGetNamedBufferParameterui64vNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLGETINTEGERUI64VNVPROC, glGetIntegerui64vNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLUNIFORMUI64NVPROC, glUniformui64NV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLUNIFORMUI64VNVPROC, glUniformui64vNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLGETUNIFORMUI64VNVPROC, glGetUniformui64vNV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLPROGRAMUNIFORMUI64NVPROC, glProgramUniformui64NV)
    GL_EXTENSION_FUNC(NV_shader_buffer_load, PFNGLPROGRAMUNIFORMUI64VNVPROC, glProgramUniformui64vNV)

GL_EXTENSION(NV_vertex_buffer_unified_memory)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLBUFFERADDRESSRANGENVPROC, glBufferAddressRangeNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLVERTEXFORMATNVPROC, glVertexFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLNORMALFORMATNVPROC, glNormalFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLCOLORFORMATNVPROC, glColorFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLINDEXFORMATNVPROC, glIndexFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLTEXCOORDFORMATNVPROC, glTexCoordFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLEDGEFLAGFORMATNVPROC, glEdgeFlagFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLSECONDARYCOLORFORMATNVPROC, glSecondaryColorFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLFOGCOORDFORMATNVPROC, glFogCoordFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLVERTEXATTRIBFORMATNVPROC, glVertexAttribFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLVERTEXATTRIBIFORMATNVPROC, glVertexAttribIFormatNV)
    GL_EXTENSION_FUNC(NV_vertex_buffer_unified_memory, PFNGLGETINTEGERUI64I_VNVPROC,  glGetIntegerui64i_vNV)

GL_EXTENSION(NV_bindless_multi_draw_indirect)
    GL_EXTENSION_FUNC(NV_bindless_multi_draw_indirect, PFNGLMULTIDRAWARRAYSINDIRECTBINDLESSNVPROC, glMultiDrawArraysIndirectBindlessNV)
    GL_EXTENSION_FUNC(NV_bindless_multi_draw_indirect, PFNGLMULTIDRAWELEMENTSINDIRECTBINDLESSNVPROC, glMultiDrawElementsIndirectBindlessNV)

#if 0
    GL_EXTENSION(ARB_framebuffer_object)
        GL_EXTENSION_FUNC(ARB_framebuffer_object, PFNGLGENERATEMIPMAPPROC, glGenerateMipmap)

    GL_EXTENSION(ARB_program_interface_query)
        GL_EXTENSION_FUNC(ARB_program_interface_query, PFNGLGETPROGRAMINTERFACEIVPROC, glGetProgramInterfaceiv)
        GL_EXTENSION_FUNC(ARB_program_interface_query, PFNGLGETPROGRAMRESOURCEINDEXPROC, glGetProgramResourceIndex)
        GL_EXTENSION_FUNC(ARB_program_interface_query, PFNGLGETPROGRAMRESOURCELOCATIONPROC, glGetProgramResourceLocation)
        GL_EXTENSION_FUNC(ARB_program_interface_query, PFNGLGETPROGRAMRESOURCEIVPROC, glGetProgramResourceiv)

    GL_EXTENSION(ARB_tessellation_shader)
        GL_EXTENSION_FUNC(ARB_tessellation_shader, PFNGLPATCHPARAMETERIPROC, glPatchParameteri)
        GL_EXTENSION_FUNC(ARB_tessellation_shader, PFNGLPATCHPARAMETERFVPROC, glPatchParameterfv)

    GL_EXTENSION(ARB_uniform_buffer_object)
        GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLBINDBUFFERBASEPROC, glBindBufferBase)
        GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETACTIVEUNIFORMBLOCKIVPROC, glGetActiveUniformBlockiv)
        GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETACTIVEUNIFORMSIVPROC, glGetActiveUniformsiv)
        GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETUNIFORMBLOCKINDEXPROC, glGetUniformBlockIndex)
        GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLGETUNIFORMINDICESPROC, glGetUniformIndices)
        GL_EXTENSION_FUNC(ARB_uniform_buffer_object, PFNGLUNIFORMBLOCKBINDINGPROC, glUniformBlockBinding)

    GL_EXTENSION(EXT_texture_storage)
        GL_EXTENSION_FUNC(EXT_texture_storage, PFNGLTEXSTORAGE1DPROC, glTexStorage1D)
        GL_EXTENSION_FUNC(EXT_texture_storage, PFNGLTEXSTORAGE2DPROC, glTexStorage2D)
        GL_EXTENSION_FUNC(EXT_texture_storage, PFNGLTEXSTORAGE3DPROC, glTexStorage3D)
        GL_EXTENSION_FUNC(EXT_texture_storage, PFNGLTEXTURESTORAGE1DEXTPROC, glTextureStorage1DEXT)
        GL_EXTENSION_FUNC(EXT_texture_storage, PFNGLTEXTURESTORAGE2DEXTPROC, glTextureStorage2DEXT)
        GL_EXTENSION_FUNC(EXT_texture_storage, PFNGLTEXTURESTORAGE3DEXTPROC, glTextureStorage3DEXT)

    GL_EXTENSION(NV_bindless_texture)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLGETTEXTUREHANDLENVPROC, glGetTextureHandleNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLGETTEXTURESAMPLERHANDLENVPROC, glGetTextureSamplerHandleNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLMAKETEXTUREHANDLERESIDENTNVPROC, glMakeTextureHandleResidentNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLMAKETEXTUREHANDLENONRESIDENTNVPROC, glMakeTextureHandleNonResidentNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLGETIMAGEHANDLENVPROC, glGetImageHandleNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLMAKEIMAGEHANDLERESIDENTNVPROC, glMakeImageHandleResidentNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLMAKEIMAGEHANDLENONRESIDENTNVPROC, glMakeImageHandleNonResidentNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLUNIFORMHANDLEUI64NVPROC, glUniformHandleui64NV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLUNIFORMHANDLEUI64VNVPROC, glUniformHandleui64vNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLPROGRAMUNIFORMHANDLEUI64NVPROC, glProgramUniformHandleui64NV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLPROGRAMUNIFORMHANDLEUI64VNVPROC, glProgramUniformHandleui64vNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLISTEXTUREHANDLERESIDENTNVPROC, glIsTextureHandleResidentNV)
        GL_EXTENSION_FUNC(NV_bindless_texture, PFNGLISIMAGEHANDLERESIDENTNVPROC, glIsImageHandleResidentNV)

    GL_EXTENSION(ARB_shading_language_include)
        GL_EXTENSION_FUNC(ARB_shading_language_include, PFNGLNAMEDSTRINGARBPROC, glNamedStringARB)
    
    GL_EXTENSION(ARB_debug_output)
        GL_EXTENSION_FUNC(ARB_debug_output, PFNGLDEBUGMESSAGECONTROLARBPROC, glDebugMessageControlARB)
        GL_EXTENSION_FUNC(ARB_debug_output, PFNGLDEBUGMESSAGEINSERTARBPROC, glDebugMessageInsertARB)
        GL_EXTENSION_FUNC(ARB_debug_output, PFNGLDEBUGMESSAGECALLBACKARBPROC, glDebugMessageCallbackARB)
        GL_EXTENSION_FUNC(ARB_debug_output, PFNGLGETDEBUGMESSAGELOGARBPROC, glGetDebugMessageLogARB)
#endif
    

#undef GL_CORE_EXTENSION
#undef GL_EXTENSION
#undef GL_EXTENSION_FUNC

